// PtBaseTuner.cpp: PT`[iNX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "PtBaseTuner.h"
#include <TChar.h>


/////////////////////////////////////////////////////////////////////////////
// t@C[J萔ݒ
/////////////////////////////////////////////////////////////////////////////

// foCX
#define DEVICENAME_TER	TEXT("Earthsoft PT1 ISDB-T fW^`[i")
#define DEVICENAME_SAT	TEXT("Earthsoft PT1 ISDB-S fW^`[i")

// obt@ݒ
#define FIFOBUFFTIME	2UL												// obt@ = 2b
#define FIFOBLOCKSIZE	(4096UL * 511UL / 3UL)							// ubNTCY
#define FIFOBUFFNUM		(0x3C0000UL / FIFOBLOCKSIZE * FIFOBUFFTIME)		// 30MbpsƂ


/////////////////////////////////////////////////////////////////////////////
// PT1`[iNX
/////////////////////////////////////////////////////////////////////////////

CPtManager *CPtBaseTuner::m_pPtManager = NULL;
DWORD CPtBaseTuner::m_dwInstanceCount = 0UL;

const BONGUID CPtBaseTuner::GetDeviceType(void)
{
	// foCX̃^CvԂ
	return ::BON_NAME_TO_GUID(TEXT("IHalTsTuner"));
}

const DWORD CPtBaseTuner::GetDeviceName(LPTSTR lpszName)
{
	static const TCHAR aszDeviceName[][256] = {DEVICENAME_TER, DEVICENAME_SAT};

	// foCXԂ
	if(lpszName)::_tcscpy(lpszName, aszDeviceName[m_dwTunerType]);

	return ::_tcslen(aszDeviceName[m_dwTunerType]);
}

const DWORD CPtBaseTuner::GetTotalDeviceNum(void)
{
	// `[ȋԂ
	return m_pPtManager->GetTotalTunerNum(m_dwTunerType);
}

const DWORD CPtBaseTuner::GetActiveDeviceNum(void)
{
	// gp̃`[iԂ
	return m_pPtManager->GetActiveTunerNum(m_dwTunerType);
}

const bool CPtBaseTuner::OpenTuner(void)
{
	// UN[Y
	CloseTuner();
	
	try{
		// `[iI[v
		if(!(m_pTuner = m_pPtManager->OpenTuner(m_dwTunerType)))throw ::BON_EXPECTION(TEXT("`[iI[vs"));

		// ftHg`lݒ
		if(!SetChannel(m_dwCurSpace, m_dwCurChannel))throw ::BON_EXPECTION(TEXT("`lݒ莸s"));

		// FIFOobt@m
		m_BlockPool.resize(FIFOBUFFNUM, CMediaData(FIFOBLOCKSIZE));
		m_itFreeBlock = m_BlockPool.begin();

		// Xg[MJn
		if(!m_pTuner->StartStream(this))throw ::BON_EXPECTION(TEXT("TSXg[MJns"));
		}
	catch(CBonException &Exception){
		// G[
		Exception.Notify();
		CloseTuner();
		return false;
		}
	
	return true;
}

void CPtBaseTuner::CloseTuner(void)
{
	// `[iN[Y
	if(m_pTuner){
		m_pTuner->StopStream();
		m_pTuner->CloseTuner();
		m_pTuner = NULL;
		}
	
	// FIFOobt@J
	{
		CBlockLock AutoLock(&m_FifoLock);
	
		while(!m_FifoBuffer.empty())m_FifoBuffer.pop();
		m_BlockPool.clear();
	}
}

const DWORD CPtBaseTuner::EnumTuningSpace(const DWORD dwSpace, LPTSTR lpszSpace)
{
	// gp\ȃ`[jOԂԂ
	if(dwSpace >= m_dwSpaceNum)return 0UL;

	// `[jOԖRs[
	if(lpszSpace)::_tcscpy(lpszSpace, m_pTuningSpace[dwSpace].szSpaceName);

	// `[jOԖԂ
	return ::_tcslen(m_pTuningSpace[dwSpace].szSpaceName);
}

const DWORD CPtBaseTuner::EnumChannelName(const DWORD dwSpace, const DWORD dwChannel, LPTSTR lpszChannel)
{
	// gp\ȃ`lԂ
	if(dwSpace >= m_dwSpaceNum)return 0UL;

	if(dwChannel >= m_pTuningSpace[dwSpace].dwChNum)return 0UL;

	// `lRs[
	if(lpszChannel)::_tcscpy(lpszChannel, m_pTuningSpace[dwSpace].pChConfig[dwChannel].szChName);

	// `lԂ
	return ::_tcslen(m_pTuningSpace[dwSpace].pChConfig[dwChannel].szChName);
}

const DWORD CPtBaseTuner::GetCurSpace(void)
{
	// ݂̃`[jOԂԂ
	return m_dwCurSpace;
}

const DWORD CPtBaseTuner::GetCurChannel(void)
{
	// ݂̃`lԂ
	return m_dwCurChannel;
}

const bool CPtBaseTuner::SetChannel(const DWORD dwSpace, const DWORD dwChannel)
{
	// ȂAhNXŃI[o[ChȂ΂ȂȂ
	::BON_ASSERT(false);
	
	return false;
}

const bool CPtBaseTuner::SetLnbPower(const bool bEnable)
{
	// LNBd
	return (m_pTuner)? m_pTuner->SetLnbPower(bEnable) : false;
}

const float CPtBaseTuner::GetSignalLevel(void)
{
	// CNR擾
	return (m_pTuner)? m_pTuner->GetSignalLevel() : 0.0f;
}

const bool CPtBaseTuner::GetStream(BYTE **ppStream, DWORD *pdwSize, DWORD *pdwRemain)
{
	CBlockLock AutoLock(&m_FifoLock);

	// MFIFOobt@Xg[o
	if(!m_pTuner){
		// `[iI[vĂȂ
		return false;
		}
	else if(m_FifoBuffer.empty()){
		// o\ȃf[^Ȃ
		if(ppStream)*ppStream = NULL;
		if(pdwSize)*pdwSize = 0UL;
		if(pdwRemain)*pdwRemain = 0UL;
		}
	else{	
		// f[^o
		if(ppStream)*ppStream = m_FifoBuffer.front()->GetData();
		if(pdwSize)*pdwSize = m_FifoBuffer.front()->GetSize();

		m_FifoBuffer.pop();
		
		if(pdwRemain)*pdwRemain = m_FifoBuffer.size();
		}

	return true;
}

void CPtBaseTuner::PurgeStream(void)
{
	// FIFOobt@NA
	CBlockLock AutoLock(&m_FifoLock);
	
	while(!m_FifoBuffer.empty())m_FifoBuffer.pop();
}

const DWORD CPtBaseTuner::WaitStream(const DWORD dwTimeOut)
{
	// Xg[EFCg
	return m_FifoEvent.WaitEvent(dwTimeOut);
}

const DWORD CPtBaseTuner::GetAvailableNum(void)
{
	// o\Xg[Ԃ
	return m_FifoBuffer.size();
}

CPtBaseTuner::CPtBaseTuner(IBonObject *pOwner, const Device::ISDB dwTunerType, const PT_CH_SPACE *pTuningSpace, const DWORD dwSpaceNum)
	: CBonObject(pOwner)
	, m_pTuner(NULL)
	, m_dwTunerType(dwTunerType)
	, m_pTuningSpace(pTuningSpace)
	, m_dwSpaceNum(dwSpaceNum)
	, m_dwCurSpace(0UL)
	, m_dwCurChannel(0UL)
{
	// }l[WCX^X
	if(!m_dwInstanceCount++){
		m_pPtManager = new CPtManager;
		}

	::BON_ASSERT(m_pPtManager != NULL);
}

CPtBaseTuner::~CPtBaseTuner(void)
{
	CloseTuner();
	
	// }l[WCX^XJ
	if(!--m_dwInstanceCount){
		BON_SAFE_DELETE(m_pPtManager);
		}
}

void CPtBaseTuner::OnTsStream(CPtTuner *pTuner, const BYTE *pData, const DWORD dwSize)
{
	CBlockLock AutoLock(&m_FifoLock);
	
	if(m_FifoBuffer.size() < FIFOBUFFNUM){
		// FIFOɓ
		m_itFreeBlock->SetData(pData, dwSize);
		m_FifoBuffer.push(&(*m_itFreeBlock));
		if(++m_itFreeBlock == m_BlockPool.end())m_itFreeBlock = m_BlockPool.begin();
		
		// CxgZbg
		m_FifoEvent.SetEvent();
		}
	else{
		::BON_TRACE(TEXT("FIFOobt@I[o[t[\n"));
		}
}
